program Hamming;{Graphs of the concentration function}
  uses crt, graph, graphpl;
  const n=1023;
  var ee:double;
      k:longint;

  function mesure(eps:double):double;
    var m,a,p:double;
        k,i:longint;
    begin
      a:=1;
      k:=trunc(eps*n);
      p:=1;
      for i:=1 to n do
        p:=2*p;
      if eps>0
        then
          m:=1/p
        else m:=0;
      for i:=1 to k do
        begin
          a:=a*(n-i+1)/i;
          m:=m+a/p;
        end;
      if eps=1/2
        then
          mesure:=1/2
        else
          mesure:=m
    end;

    procedure graphic;
      var i,j:integer;
          eps:double;
      begin
        opengraph;
        line(10,440,610,440);
        line(10,440,10,40);
        for i:=0 to 600 do
          begin
            eps:=i/1200;
            j:=440-trunc(mesure(1/2-eps)*800);
            putpixel(i+10,j,14);
            if i = 0 then Circle(i+10,j,2)
          end
      end;

begin
  TextColor(14);
  TextBackGround(1);
  ClrScr;
  for k:=0 to (n div 2) do
    begin
      ee:=k/n;
      writeln('k=',k:4,' alfa=',mesure(1/2-ee));
    end;
  {readln;}
  graphic;
  repeat until keypressed;
  closegraph
end.